//+------------------------------------------------------------------+
//|                                                        Bulls.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//2008fxtsd bulls+bears
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 SlateGray
//---- input parameters
extern int period=13;
//---- buffers
double BullsBuffer[];
double BearsBuffer[];
double TempBuffer[];
double TempBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(4);
   IndicatorDigits(Digits);
//---- indicator line


   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_HISTOGRAM);



   SetIndexBuffer(0,BullsBuffer);
   SetIndexBuffer(1,BearsBuffer);
   SetIndexBuffer(2,TempBuffer);
   SetIndexBuffer(3,TempBuffer1);



//---- name for DataWindow and indicator subwindow label
   short_name="Bulls - Bears ("+period+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Bulls");
   SetIndexLabel(1,"Bears");
   SetIndexLabel(2,short_name);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=period) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      TempBuffer1[i]=iMA(NULL,0,period,0,MODE_EMA,PRICE_CLOSE,i);
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
     BullsBuffer[i]=High[i]-TempBuffer1[i];
     BearsBuffer[i]=Low [i]-TempBuffer1[i];
     TempBuffer[i]=BullsBuffer[i] + BearsBuffer[i];

      i--;
     }
     
     
//----
   return(0);
  }
//+------------------------------------------------------------------+